<script setup lang="ts">
import { defineEmits, defineProps } from 'vue'

const props = defineProps({
  variant: {
    type: String,
    default: 'primary',
  },
  title: {
    type: String,
    default: null,
  },
  subtitle: {
    type: String,
    default: null,
  },
  time: {
    type: String,
    default: null,
  },
  icon: {
    type: String,
    default: null,
  },
  fillBorder: {
    type: Boolean,
    default: false,
  },
})

const emit = defineEmits()
interface Props {
  variant?: string
  title?: string | null
  subtitle?: string | null
  time?: string | null
  icon?: string | null
  fillBorder?: boolean
}
</script>

<template>
  <li
    v-bind="$attrs"
    class="timeline-item"
    :class="[
      `timeline-variant-${variant}`,
      fillBorder ? `timeline-item-fill-border-${variant}` : null,
    ]"
    v-on="listeners"
  >
    <div
      v-if="!icon"
      class="timeline-item-point"
    />
    <div
      v-else
      class="timeline-item-icon d-flex align-center justify-center rounded-circle"
    >
      <VsIcon :icon="icon" />
    </div>

    <slot>
      <div class="timeline-content d-flex flex-column flex-md-row flex-wrap justify-space-between mb-1 mb-md-0">
        <h6
          class="timeline-title"
          v-text="title"
        />
        <small
          class="timeline-item-time text-nowrap"
          v-text="time"
        />
      </div>
      <p
        class="timeline-subtitle mb-0"
        v-text="subtitle"
      />
    </slot>
  </li>
</template>

<style scoped>
:root {
  --primary-color: #2196f3;
  --success-color: #4caf50;
  --danger-color: #f44336;
  --dark-border-color: #424242;
  --dark-surface-color: #303030;
  --light-background: #ffffff;
  --border-color: #e0e0e0;
}

.timeline-item {
  padding-left: 2.5rem;
  position: relative;
  margin-bottom: 2rem;
  border-left: 1px solid var(--border-color);
  background-color: var(--light-background);
  box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
  transition: box-shadow 0.3s ease;
}

.timeline-item:hover {
  box-shadow: 0 6px 12px rgba(0, 0, 0, 0.15);
}

.timeline-item:last-of-type:after {
  content: '';
  position: absolute;
  left: 0;
  bottom: 0;
  width: 1px;
  height: 100%;
  background: linear-gradient(var(--border-color), var(--light-background));
}

.timeline-item-point {
  position: absolute;
  left: -8px;
  width: 16px;
  height: 16px;
  top: 0;
  border-radius: 50%;
  z-index: 1;
  background-color: var(--primary-color);
  box-shadow: 0 0 0 4px rgba(var(--primary-color), 0.2);
}

.timeline-item-point::before {
  content: '';
  position: absolute;
  width: 24px;
  height: 24px;
  top: -4px;
  left: -4px;
  border-radius: 50%;
  background-color: rgba(var(--primary-color), 0.2);
}

.timeline-item-icon {
  position: absolute;
  left: -16px;
  top: 0;
  width: 32px;
  height: 32px;
  background-color: var(--light-background);
  border: 2px solid var(--primary-color);
  color: var(--primary-color);
  border-radius: 50%;
  display: flex;
  align-items: center;
  justify-content: center;
  z-index: 1;
}

.timeline-content {
  display: flex;
  flex-direction: column;
  justify-content: space-between;
}

.timeline-title {
  font-size: 1rem;
  font-weight: 600;
  color: var(--primary-color);
}

.timeline-item-time {
  font-size: 0.875rem;
  color: #6c757d;
}

.timeline-subtitle {
  font-size: 0.875rem;
  color: #212529;
}

.timeline-variant-primary .timeline-item-point {
  background-color: var(--primary-color);
}

.timeline-variant-success .timeline-item-point {
  background-color: var(--success-color);
}

.timeline-variant-danger .timeline-item-point {
  background-color: var(--danger-color);
}

.timeline-item-fill-border-primary {
  border-color: var(--primary-color) !important;
}

.timeline-item-fill-border-success {
  border-color: var(--success-color) !important;
}

.timeline-item-fill-border-danger {
  border-color: var(--danger-color) !important;
}

.theme--dark .timeline-item {
  border-left-color: var(--dark-border-color);
  background-color: var(--dark-surface-color);
}

.theme--dark .timeline-item:last-of-type:after {
  background: linear-gradient(var(--dark-border-color), var(--dark-surface-color));
}

.theme--dark .timeline-item-icon {
  background-color: var(--dark-surface-color);
  border-color: var(--dark-border-color);
  color: var(--dark-border-color);
}
</style>
